/*
 Mixer.c - scramble columns of an input file

 By Roy Stedman @ Atari 07FEB92
*/

#include <stdio.h>

#define LINESIZE 250
#define FILE1 infile
#define FILE2 stdin
#define SPACE ' '

char	srcline[LINESIZE+2];	/* DO NOT OVERFLOW THESE!!! */
char	destline[LINESIZE+2];	
int	translate[LINESIZE+2];	/* translation col n = [n] */
FILE	*FILE1;

int	maxinlen, maxoutlen;	/* length of input lines */

/* 
-----------------------------------------------------------
 convert - reads and converts srcline to destline thru 
	translate table. 
	destline is padded with spaces to LINESIZE
-----------------------------------------------------------
*/
convert(s,d)
char *s;
char *d;
{
	int i,j;
	
	for (i=0; i<maxoutlen; i++) d[i] = SPACE;
	d[i++] = '\n'; d[i++] = 0; d[i++] = 0; d[i++] = 'Q';
	while(fgets(s,LINESIZE,FILE2) > 0) {
		if (strlen(s) < maxinlen) { for(j=strlen(s); j<maxinlen-1; j++) s[j] = ' '; s[j++] = '\n'; }
		for(i=0; i<maxinlen; i++) {
			if ( translate[i] > 0 ) 
				d[translate[i]] = s[i];
		}
		printf("%s\n",d);
	}
}

/*
-----------------------------------------------------------
buildxlate - creates translate table out of input file
	1 row per line
-----------------------------------------------------------
*/
buildxlate()
{
	int i=0;
	
	maxoutlen = 0;
	for(i=0; i<LINESIZE; i++) translate[i] = -1;
	i = 0;
	while(!feof(FILE1)) {
		fscanf(FILE1,"%*s %d ",&translate[i]);
/*		printf("Added column: %d = %d\n",i,translate[i]);	*/
		if (translate[i] > maxoutlen) maxoutlen = translate[i]; 	
		i++;
	}
	maxinlen = i;
}	

/*
-------------------------------------
main program
-------------------------------------

*/
main(argc, argv)
int	argc;
char	*argv[];
{
	printf("Trying to open mix file\n");
	FILE1 = fopen(argv[1],"r");
	printf("building translate table\n");
	buildxlate();
	fclose(FILE1);
	printf("converting files\n");
	convert(srcline,destline);
}
              
